<%--
    Copyright 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago4Q.

    Spago4Q is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published 
    by the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spago4Q is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
--%>

<%@ include file="/jsp/portlet_base.jsp"%>
<%@page import="java.util.List"%>
<%@page import="java.util.Map"%>
<%@page import="java.util.HashMap"%>
<%@page import="it.eng.spago.dispatching.service.detail.impl.DelegatedDetailService"%>
<%@page import="java.util.Vector"%>
<%@page import="it.eng.spago4q.utilities.modelKpiUtilities.AlreadyAssignedAssessmentUtil"%>

<%
String title = "";
SourceBean moduleBean = (SourceBean) spagoconfig.getFilteredSourceBeanAttribute("MODULES.MODULE", "NAME","DetailAssessmentModelModule");
if (moduleBean.getAttribute("CONFIG.TITLE") != null)
  title = (String) moduleBean.getAttribute("CONFIG.TITLE");
String message = DelegatedDetailService.DETAIL_INSERT;

Map backUrlPars = new HashMap();
backUrlPars.put("PAGE", "AssessmentModelPage");
String backUrl = urlBuilder.getUrl(request, backUrlPars);

Map formUrlPars = new HashMap();
formUrlPars.put("PAGE", "AssessmentModelKPIPage");
formUrlPars.put("MODULE", "DetailAssessmentKpiModule");
formUrlPars.put("MESSAGE", message);
String formUrl = urlBuilder.getUrl(request, formUrlPars);

RequestContainer requestContainer=RequestContainer.getRequestContainer();
String type=(String)requestContainer.getServiceRequest().getAttribute("type");
String ma=(String)requestContainer.getServiceRequest().getAttribute("id");
String af=(String)requestContainer.getServiceRequest().getAttribute("af");
String ac=(String)requestContainer.getServiceRequest().getAttribute("ac");
String at=(String)requestContainer.getServiceRequest().getAttribute("at");
String ap=(String)requestContainer.getServiceRequest().getAttribute("ap");
String kpi=new String("0");
// Checking wich are the sons of the current node, if there are no nodes free the save button must not be displayed
Boolean none=true;
Vector<String> assignedIds=new Vector();

if(!type.equalsIgnoreCase("ap")){  // no insert option for type assessment practice
    AlreadyAssignedAssessmentUtil alreadyAssignedAssessmentUtil=new AlreadyAssignedAssessmentUtil(ma,af,ac,at);
    alreadyAssignedAssessmentUtil.runFunctions(type);
    assignedIds=alreadyAssignedAssessmentUtil.getAssignedIds();
    none=alreadyAssignedAssessmentUtil.getNone();
}
%>

<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
<title><%=title%></title>
</head>
<body>
<table class='header-table-portlet-section'>
  <tr class='header-row-portlet-section'>
    <td class='header-title-column-portlet-section'
      style='vertical-align: middle; padding-left: 5px;'>
      <spago4q:message key="<%=title%>" /></td>
    <td class='header-empty-column-portlet-section'>&nbsp;</td>
       <% // limits the save function to some types 
    if(none.equals(false)){
    %>
    <td class='header-button-column-portlet-section'>
    <a href="javascript:document.getElementById('assessmentKpiForm').submit()"> 
    <img class='header-button-image-portlet-section'
      title='<spago4q:message key = "s4q.button.save.title" />'
      src='<%=urlBuilder.getResourceLink(request, "/img/save.png")%>'
      alt='<spago4q:message key = "s4q.button.save.title" />' /> </a></td>
   <%}
     else
     {%>
        <td class='header-empty-column-portlet-section'>&nbsp;</td>
     <%
     }
     %>
    <td class='header-button-column-portlet-section'><a
      href='<%=backUrl%>'> <img
      class='header-button-image-portlet-section'
      title='<spago4q:message key = "s4q.button.back.title" />'
      src='<%=urlBuilder.getResourceLink(request, "/img/back.png")%>'
      alt='<spago4q:message key = "s4q.button.back.title" />' /> </a></td>
  </tr>
</table>

<table width="100%" style="margin-top:3px; margin-left:3px; margin-right:3px; margin-bottom:5px;">
<tr height = "20">
<td class="td_tree">  <!-- Column with the navigation tree -->

<%

//drawing the tree

SessionContainer sessionContainer=requestContainer.getSessionContainer();
SourceBean tranPar= (SourceBean)sessionContainer.getAttribute("objectsList");
List objectsList=(List)tranPar.getAttributeAsList("ROW");

%>

<spago4q:treeObjects moduleName="ListAssessmentModelKPIModule"
  htmlGeneratorClass="it.eng.spago4q.presentation.tags.treehtmlgenerators.AssessmentModelTreeHtmlGenerator" 
  list_="<%=objectsList%>"/>
</td>
<td class="td_form">

<% 

//swith on the type 
if(type.equalsIgnoreCase("ma")){
  String ma_name=(String)requestContainer.getServiceRequest().getAttribute("ma_name");
  %>  
        <div class='div_detail_label'>
        <span class='portlet-form-field-label'> 
          <spago4q:message key="s4q.treeStructure.modelAssessment" /> 
          </span>
        </div>
        <div class='div_detail_form'>
        <%=ma_name%></div>
    <BR>
       <form method='POST' action='<%=formUrl%>' id='assessmentKpiForm' name='assessmentKpiForm'>
        <input type='hidden' value='<%=ma%>' name='ma' />
          <div class='div_detail_label'>
          <span class='portlet-form-field-label'> 
                <spago4q:message key="s4q.treeStructure.assessmentFramework" /> </span></div>
            <div class='div_detail_form'>
      <spago4q:addingFormList statementName="LIST_ASSESSMENT_FRAMEWORK" formName="af" assignedIds="<%=assignedIds%>"/>
        </div>
        <input type='hidden' value='<%=ac%>' name='ac' />
        <input type='hidden' value='<%=at%>' name='at' />
        <input type='hidden' value='<%=ap%>' name='ap' />
        <input type='hidden' value='<%=kpi%>' name='kpi' />
      </form>
  <% 
}

else if(type.equalsIgnoreCase("af")){    // case assessment framework
  String assessmentFrameworkName=(String)requestContainer.getServiceRequest().getAttribute("af_name");
%>  
      <div class='div_detail_label'>
      <span class='portlet-form-field-label'> 
        <spago4q:message key="s4q.treeStructure.assessmentFramework" /> 
        </span>
      </div>
      <div class='div_detail_form'>
    <%=assessmentFrameworkName%></div>
  <BR>
     <form method='POST' action='<%=formUrl%>' id='assessmentKpiForm' name='assessmentKpiForm'>
      <input type='hidden' value='<%=ma%>' name='ma' />
      <input type='hidden' value='<%=af%>' name='af' />
        <div class='div_detail_label'>
        <span class='portlet-form-field-label'> 
              <spago4q:message key="s4q.treeStructure.assessmentCategory" /> </span></div>
          <div class='div_detail_form'>
      <spago4q:addingFormList statementName="LIST_ASSESSMENT_CATEGORY" formName="ac" whereClauseName="id_assessment_framework" whereClauseValue="<%=af%>" assignedIds="<%=assignedIds%>"/>
      </div>
      <input type='hidden' value='<%=at%>' name='at' />
      <input type='hidden' value='<%=ap%>' name='ap' />
      <input type='hidden' value='<%=kpi%>' name='kpi' />
</form>
<% 

}
else if(type.equalsIgnoreCase("ac")){     // case information need
  String assessmentCategoryName=(String)requestContainer.getServiceRequest().getAttribute("ac_name");
  %>  
        <div class='div_detail_label'>
        <span class='portlet-form-field-label'> 
          <spago4q:message key="s4q.treeStructure.assessmentCategory" /> 
        </span>
        </div>
        <div class='div_detail_form'>
     <%=assessmentCategoryName%></div>
  <BR>
  <form method='POST' action='<%=formUrl%>' id='assessmentKpiForm' name='assessmentKpiForm'>
      <input type='hidden' value='<%=ma%>' name='ma' />
      <input type='hidden' value='<%=af%>' name='af' />
      <input type='hidden' value='<%=ac%>' name='ac' />
      <div class='div_detail_label'>
        <span class='portlet-form-field-label'> 
              <spago4q:message key="s4q.treeStructure.assessmentTarget" /> </span></div>
          <div class='div_detail_form'>
      <spago4q:addingFormList statementName="LIST_ASSESSMENT_TARGET" formName="at" whereClauseName="id_assessment_category" whereClauseValue="<%=ac%>" assignedIds="<%=assignedIds%>"/>
      </div>
      <input type='hidden' value='<%=ap%>' name='ap' />
       <% if(none.equals(false)){ %>
            <BR>
            <div class='div_detail_label'>
                <span class='portlet-form-field-label'> 
                  <spago4q:message key="s4q.treeStructure.Kpi" /> </span></div>
            <div class='div_detail_form'>
                 <spago4q:kpiList currentKpi="<%=kpi%>" />
            </div>
      <%} %>
      </form>
    <% 
}
else if(type.equalsIgnoreCase("at")){          // assessment target case
  String assessmentTargetName=(String)requestContainer.getServiceRequest().getAttribute("at_name");
  %>  
    <div class='div_detail_label'><span
      class='portlet-form-field-label'> 
      <spago4q:message key="s4q.treeStructure.assessmentTarget" /> </span></div>
    <div class='div_detail_form'>
    <%=assessmentTargetName%></div>
<BR>
  <form method='POST' action='<%=formUrl%>' id='assessmentKpiForm' name='assessmentKpiForm'>
      <input type='hidden' value='<%=ma%>' name='ma' />
     <input type='hidden' value='<%=af%>' name='af' />
      <input type='hidden' value='<%=ac%>' name='ac' />
      <input type='hidden' value='<%=at%>' name='at' />
      <div class='div_detail_label'>
        <span class='portlet-form-field-label'> 
              <spago4q:message key="s4q.treeStructure.assessmentPractice" /> </span></div>
          <div class='div_detail_form'>
      <spago4q:addingFormList statementName="LIST_ASSESSMENT_PRACTICE" formName="ap" whereClauseName="id_assessment_target" whereClauseValue="<%=at%>" assignedIds="<%=assignedIds%>"/>
      </div>
    <% if(none.equals(false)){ %>
       <BR>
       <div class='div_detail_label'>
          <span class='portlet-form-field-label'> 
              <spago4q:message key="s4q.treeStructure.Kpi" /> </span></div>
       <div class='div_detail_form'>
             <spago4q:kpiList currentKpi="<%=kpi%>" />
       </div>
    <%} %>
</form>

<% 
}
else if(type.equalsIgnoreCase("ap")){}

%>
</td>
</tr>
</table>
<spago4q:error />

</body>
</html>