<%--
    Copyright 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago4Q.

    Spago4Q is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published 
    by the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spago4Q is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
--%>

<%@ page language="java"
         contentType="text/html; charset=UTF-8"
         pageEncoding="UTF-8"
         session="true" 
         import="it.eng.spago.base.*,
         		 it.eng.spago.configuration.ConfigSingleton,
         		 it.eng.spago4q.utilities.urls.IUrlBuilder,
         		 it.eng.spago4q.utilities.messages.IMessageBuilder"
%>
<%@page import="it.eng.spago4q.utilities.urls.WebUrlBuilder"%>
<%@page import="it.eng.spago4q.utilities.urls.PortletUrlBuilder"%>
<%@page import="it.eng.spago4q.utilities.messages.MessageBuilder"%>
<%@page import="it.eng.spago4q.utilities.messages.MessageBuilderFactory"%>
<%@page import="it.eng.spago4q.utilities.urls.UrlBuilderFactory"%>
<%@page import="it.eng.spago4q.utilities.Spago4QConstants"%>

<!-- IMPORT TAG LIBRARY  -->
<%@ taglib uri="/WEB-INF/tld/spago4q.tld" prefix="spago4q" %>

<!-- GET SPAGO OBJECTS  -->
<%
	RequestContainer aRequestContainer = null;
	ResponseContainer aResponseContainer = null;
	SessionContainer aSessionContainer = null;
	IUrlBuilder urlBuilder = null;
	IMessageBuilder msgBuilder = null;
	
	// get configuration
	ConfigSingleton spagoconfig = ConfigSingleton.getInstance();
	// get mode of execution
	String sbiMode = null;
		
	// case of portlet mode
	aRequestContainer = RequestContainerPortletAccess.getRequestContainer(request);
	aResponseContainer = ResponseContainerPortletAccess.getResponseContainer(request);
	if (aRequestContainer == null) {
		// case of web mode
		aRequestContainer = RequestContainerAccess.getRequestContainer(request);
		aResponseContainer = ResponseContainerAccess.getResponseContainer(request);
	}
	
	String channelType = aRequestContainer.getChannelType();
	if (Spago4QConstants.SPAGO4Q_MODE_PORTLET.equalsIgnoreCase(channelType)) sbiMode = Spago4QConstants.SPAGO4Q_MODE_PORTLET;
	else sbiMode = Spago4QConstants.SPAGO4Q_MODE_WEB;
	
	// create url builder 
	urlBuilder = UrlBuilderFactory.getUrlBuilder(sbiMode);

	// create message builder
	msgBuilder = MessageBuilderFactory.getMessageBuilder();
	
	// get other spago object
	SourceBean aServiceRequest = aRequestContainer.getServiceRequest();
	SourceBean aServiceResponse = aResponseContainer.getServiceResponse();
	aSessionContainer = aRequestContainer.getSessionContainer();
	
	// urls for resources
	String linkSpago4Qjs = urlBuilder.getResourceLink(request, "/js/spago4q.js");
	String linkProto = urlBuilder.getResourceLink(request, "/js/prototype/javascripts/prototype.js");
	String linkProtoWin = urlBuilder.getResourceLink(request, "/js/prototype/javascripts/window.js");
	String linkProtoEff = urlBuilder.getResourceLink(request, "/js/prototype/javascripts/effects.js");
	String linkProtoDefThem = urlBuilder.getResourceLink(request, "/js/prototype/themes/default.css");
	String linkProtoAlphaThem = urlBuilder.getResourceLink(request, "/js/prototype/themes/alphacube.css");
%>
 
<SCRIPT language='JavaScript' src='<%=linkSpago4Qjs%>'></SCRIPT>
<%--
<script type="text/javascript" src="<%=linkProto%>"></script>
<script type="text/javascript" src="<%=linkProtoWin%>"></script>
<script type="text/javascript" src="<%=linkProtoEff%>"></script>
<link href="<%=linkProtoDefThem%>" rel="stylesheet" type="text/css"/>
<link href="<%=linkProtoAlphaThem%>" rel="stylesheet" type="text/css"/>
--%>
   
<!-- based on ecexution mode include initial html  -->   
<% if (sbiMode.equalsIgnoreCase(Spago4QConstants.SPAGO4Q_MODE_WEB)){ %> 

<html>
<body>
<%} %>


<!-- import css  --> 
<%
	// based on mode import right css 
	if (sbiMode.equalsIgnoreCase(Spago4QConstants.SPAGO4Q_MODE_WEB)) {
%>
<LINK rel='StyleSheet' 
      href='<%=urlBuilder.getResourceLink(request, "css/spago4q_wa.css")%>' 
      type='text/css' />
<%  } else {  %>
<LINK rel='StyleSheet' 
      href='<%=urlBuilder.getResourceLink(request, "css/spago4q_portlet.css")%>' 
      type='text/css' />
<%	} %>

<LINK rel='StyleSheet' 
      href='<%=urlBuilder.getResourceLink(request, "css/spago4q_shared.css")%>' 
      type='text/css' />

<LINK rel='StyleSheet' 
      href='<%=urlBuilder.getResourceLink(request, "css/jsr168.css")%>' 
      type='text/css' />
      
<LINK rel='StyleSheet' 
      href='<%=urlBuilder.getResourceLink(request, "css/external.css")%>' 
      type='text/css' />
      
<LINK rel='StyleSheet' 
      href='<%=urlBuilder.getResourceLink(request, "css/menu.css")%>' 
      type='text/css' />

<script>
	document.onselectstart = function() { return true; }
</script>

