/*
 *   Copyright 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago4Q.

    Spago4Q is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published 
    by the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spago4Q is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package it.eng.spago4q.presentation.tags;

import it.eng.spago.dbaccess.DataConnectionManager;
import it.eng.spago.dbaccess.sql.DataConnection;
import it.eng.spago.dbaccess.sql.DataField;
import it.eng.spago.dbaccess.sql.DataRow;
import it.eng.spago.dbaccess.sql.SQLCommand;
import it.eng.spago.dbaccess.sql.result.DataResult;
import it.eng.spago.dbaccess.sql.result.ScrollableDataResult;
import it.eng.spago.error.EMFInternalError;

import java.io.IOException;
import java.util.HashMap;
import java.util.Iterator;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;

/*
 * This tags takes as input a vector of names and draws a combo box
 */
public class DataSourceParameterTag extends TagSupport {

	protected HttpServletRequest httpRequest = null;
	protected DataConnection dataConnection=null;
	protected SQLCommand sqlCommand = null;
	protected DataResult dataResult = null;
	protected ScrollableDataResult scrollableDataResult=null;

	protected HashMap<String, Boolean> parNames=null;
	protected String e_data_source_id=null;




	@Override
	public int doStartTag() throws JspException {

		Boolean encrypted=false;
		StringBuffer htmlStream = new StringBuffer();
		String value="";

		htmlStream.append("<div class=\"div_detail_area_forms\" >");
		for (Iterator iterator = parNames.keySet().iterator(); iterator.hasNext();) {
			String name = (String) iterator.next();
			encrypted=parNames.get(name);

			value=getTheValue(name);
			
			if(encrypted==false){

			htmlStream.append("<div class='div_detail_label'>" +
					"			<span class='portlet-form-field-label'> " +
					"			"+name+"</span></div>"+
					"			<div class='div_detail_form'>"+
					"  			<input class='portlet-form-input-field' type=\"text\" name=\""+name+"\" size=\"50\""+
					"			value=\""+value+"\" maxlength=\"200\"> &nbsp;</div>");
			}
			else{
				htmlStream.append("<div class='div_detail_label'>" +
						"			<span class='portlet-form-field-label'> " +
						"			"+name+"</span></div>"+
						"			<div class='div_detail_form'>"+
						"  			<input class='portlet-form-input-field' type=\"password\" name=\""+name+"\" size=\"50\""+
						"			value=\""+value+"\" maxlength=\"200\"> &nbsp;</div>");
				
				//I send also the old password, to encrypt it only if it has been changed
				String oldName="old"+name;
				htmlStream.append("<input type=\"hidden\" name=\""+oldName+"\" value=\""+value+"\"/>");

			}
			
			}
htmlStream.append("</div>");
	

		try {
			pageContext.getOut().print(htmlStream);
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		
		return SKIP_BODY;
		
	}


	public String getTheValue(String name){

		String value="";
		httpRequest = (HttpServletRequest) pageContext.getRequest();
		try{
			DataConnectionManager dataConnectionManager=DataConnectionManager.getInstance();
			dataConnection=dataConnectionManager.getConnection("spago4q");
			String statement = "select value from e_data_source_parameters where e_data_source_id="+e_data_source_id+" AND name='"+name+"'";
			sqlCommand = dataConnection.createSelectCommand(statement);
			dataResult = sqlCommand.execute();

			ScrollableDataResult scrollableDataResult = (ScrollableDataResult)dataResult.getDataObject();
			if(scrollableDataResult.getRowsNumber()>0){
			DataRow dataRow=scrollableDataResult.getDataRow();
			DataField dataField=dataRow.getColumn("value");
			value=dataField.getStringValue();
			}

		}
		catch (Exception e) {
		}
		finally{

			try {
				if(dataConnection!=null)dataConnection.close();
				if(scrollableDataResult!=null)scrollableDataResult.close();
			} catch (EMFInternalError e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

		if(value!=null)
			return value;
		else return "";


	}





public String getE_data_source_id() {
	return e_data_source_id;
}



public void setE_data_source_id(String e_data_source_id) {
	this.e_data_source_id = e_data_source_id;
}


public HashMap<String, Boolean> getParNames() {
	return parNames;
}


public void setParNames(HashMap<String, Boolean> parNames) {
	this.parNames = parNames;
}



}
