/*
 *   Copyright 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago4Q.

    Spago4Q is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published 
    by the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spago4Q is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package it.eng.spago4q.presentation.tags;

import it.eng.spago.dbaccess.DataConnectionManager;
import it.eng.spago.dbaccess.sql.DataConnection;
import it.eng.spago.dbaccess.sql.DataField;
import it.eng.spago.dbaccess.sql.DataRow;
import it.eng.spago.dbaccess.sql.SQLCommand;
import it.eng.spago.dbaccess.sql.result.DataResult;
import it.eng.spago.dbaccess.sql.result.ScrollableDataResult;
import it.eng.spago.error.EMFInternalError;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;

public class MeasurableAttributeTag extends TagSupport {
	protected HttpServletRequest httpRequest = null;
	protected DataConnection dataConnection=null;
	protected SQLCommand sqlCommand = null;
	protected DataResult dataResult = null;
protected ScrollableDataResult scrollableDataResult =null;
	protected String id= null;
	
	private final static String getMeasurableAttribute="select table_name,field_name from dt_measurable_attribute where id_measurable_attribute=";
	
	

	@Override
	public int doStartTag() throws JspException {

		httpRequest = (HttpServletRequest) pageContext.getRequest();
		try{
		DataConnectionManager dataConnectionManager=DataConnectionManager.getInstance();
		dataConnection=dataConnectionManager.getConnection("spago4q");
		String statement = getMeasurableAttribute+id;
		sqlCommand = dataConnection.createSelectCommand(statement);
		dataResult = sqlCommand.execute();
		scrollableDataResult = (ScrollableDataResult)dataResult.getDataObject();

		DataRow dataRow=scrollableDataResult.getDataRow();
		DataField table_nameDf=dataRow.getColumn("table_name");
		DataField field_nameDf=dataRow.getColumn("field_name");
		String table_name=table_nameDf.getStringValue();
		String field_name=field_nameDf.getStringValue();
		
		StringBuffer htmlStream = new StringBuffer();
		
		
		htmlStream.append("<div class='div_detail_label'><span " +
				"class='portlet-form-field-label'> Table Name</span></div>");
		htmlStream.append("<input class='portlet-form-input-field' type=\"text\" name=\"table_name\" size=\"50\""+
			"value=\""+table_name+"\" maxlength=\"200\"> &nbsp;</div> <BR><BR>");
		
		htmlStream.append("<div class='div_detail_label'><span " +
				"class='portlet-form-field-label'> Field Name </span></div>");				
		htmlStream.append("<input class='portlet-form-input-field' type=\"text\" name=\"field_name\" size=\"50\""+
				"value=\""+field_name+"\" maxlength=\"200\"> &nbsp;</div>");
		
		pageContext.getOut().print(htmlStream);
		}
		catch (Exception e) {
		}
		finally{

				try {
					if(dataConnection!=null) dataConnection.close();
					if(scrollableDataResult!=null) scrollableDataResult.close();
				} catch (EMFInternalError e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}

			}
		return SKIP_BODY;
	}

	
	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	
	
	
	
	
}
