/*
 *   Copyright 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago4Q.

    Spago4Q is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published 
    by the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spago4Q is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package it.eng.spago4q.presentation.tags;

import java.io.IOException;
import java.util.Iterator;
import java.util.Vector;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;

/*
 * This tags takes as input a vector of names and draws a combo box
 */
public class OperationParsTag extends TagSupport {


	protected String nameForm=null;
	protected Vector<String> avalaibleNames=null;


	@Override
	public int doStartTag() throws JspException {

		StringBuffer htmlStream = new StringBuffer();
		if(avalaibleNames.size()>0){
			htmlStream.append("<select name=\""+nameForm+"\" size=\"1\">");

			for (Iterator iterator = avalaibleNames.iterator(); iterator.hasNext();) {
				String name = (String) iterator.next();
				htmlStream.append("<option value=\"" + name + "\">" + name
						+ "</option>");
			}
			htmlStream.append("</select>");
		}
		try {
			pageContext.getOut().print(htmlStream);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return SKIP_BODY;
	}



	public Vector<String> getAvalaibleNames() {
		return avalaibleNames;
	}

	public void setAvalaibleNames(Vector<String> avalaibleNames) {
		this.avalaibleNames = avalaibleNames;
	}



	public String getNameForm() {
		return nameForm;
	}



	public void setNameForm(String nameForm) {
		this.nameForm = nameForm;
	}

}
