/*
 *   Copyright 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago4Q.

    Spago4Q is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published 
    by the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spago4Q is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package it.eng.spago4q.presentation.tags;

import it.eng.spago.dbaccess.DataConnectionManager;
import it.eng.spago.dbaccess.sql.DataConnection;
import it.eng.spago.dbaccess.sql.DataField;
import it.eng.spago.dbaccess.sql.DataRow;
import it.eng.spago.dbaccess.sql.SQLCommand;
import it.eng.spago.dbaccess.sql.result.DataResult;
import it.eng.spago.dbaccess.sql.result.ScrollableDataResult;
import it.eng.spago.error.EMFInternalError;

import java.io.IOException;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;

/*
The tag creates an HTML form that lets the user choose a scale.
 */
public class ProjectListTag extends TagSupport
{
	protected HttpServletRequest httpRequest = null;
	protected DataConnection dataConnection=null;
	protected SQLCommand sqlCommand = null;
	protected DataResult dataResult = null;
	protected ScrollableDataResult scrollableDataResult=null;



	@Override
	public int doStartTag() throws JspException {

		try {

			httpRequest = (HttpServletRequest) pageContext.getRequest();
			DataConnectionManager dataConnectionManager=DataConnectionManager.getInstance();
			dataConnection=dataConnectionManager.getConnection("spago4q");
			String statement = "Select name from dt_project order by name";
			sqlCommand = dataConnection.createSelectCommand(statement);
			dataResult = sqlCommand.execute();
			ScrollableDataResult scrollableDataResult = (ScrollableDataResult)dataResult.getDataObject();

			StringBuffer htmlStream = new StringBuffer();
			htmlStream.append("<select name=\"project\" size=\"1\">");
			htmlStream.append("<option value=\"\"> </option>");
			// an option for each row in dt_scale
			for(int i=0;i<scrollableDataResult.getRowsNumber();i++){
				DataRow dataRow=scrollableDataResult.getDataRow();
				DataField nameF=dataRow.getColumn("name");
				String name=nameF.getStringValue();
				htmlStream.append("<option value=\""+name+"\"");
				// sets the current scale as selected

				htmlStream.append(">"+name+"</option>");
			}
			htmlStream.append("</select>");        
			scrollableDataResult.close();			
			pageContext.getOut().print(htmlStream);
		} catch (EMFInternalError e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} 		
		finally{
			try {
				if(dataConnection!=null) dataConnection.close();
				if(scrollableDataResult!=null) scrollableDataResult.close();
			} catch (EMFInternalError e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		return SKIP_BODY;
	}




} // public class ListTag extends TagSupport






