/*
 *   Copyright 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago4Q.

    Spago4Q is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published 
    by the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spago4Q is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package it.eng.spago4q.presentation.tags;

import it.eng.spago.dbaccess.DataConnectionManager;
import it.eng.spago.dbaccess.SQLStatements;
import it.eng.spago.dbaccess.sql.DataConnection;
import it.eng.spago.dbaccess.sql.DataField;
import it.eng.spago.dbaccess.sql.DataRow;
import it.eng.spago.dbaccess.sql.SQLCommand;
import it.eng.spago.dbaccess.sql.result.DataResult;
import it.eng.spago.dbaccess.sql.result.ScrollableDataResult;
import it.eng.spago.error.EMFInternalError;

import java.io.IOException;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;

/*
The tag creates an HTML combo box that lets the user chose a sbi document
 */
public class SbiDocListTag extends TagSupport
{
	protected HttpServletRequest httpRequest = null;
	protected DataConnection dataConnection=null;
	protected SQLCommand sqlCommand = null;
	protected DataResult dataResult = null;

	protected String currentDoc = null;


	@Override
	public int doStartTag() throws JspException {

		try {

			httpRequest = (HttpServletRequest) pageContext.getRequest();
			DataConnectionManager dataConnectionManager=DataConnectionManager.getInstance();
			dataConnection=dataConnectionManager.getConnection("spagobi");
			String statement = SQLStatements.getStatement("LIST_SBI_DOC");
			sqlCommand = dataConnection.createSelectCommand(statement);
			dataResult = sqlCommand.execute();
			ScrollableDataResult scrollableDataResult = (ScrollableDataResult)dataResult.getDataObject();

			StringBuffer htmlStream = new StringBuffer();
			htmlStream.append("<select name=\"DOCUMENT_LABEL\" size=\"1\">");

			// an option for each row in dt_scale
			for(int i=0;i<scrollableDataResult.getRowsNumber();i++){
				DataRow dataRow=scrollableDataResult.getDataRow();
				DataField idF=dataRow.getColumn("LABEL");
				DataField nameF=dataRow.getColumn("NAME");
				String id=idF.getStringValue();
				String name=nameF.getStringValue();
				htmlStream.append("<option value=\""+id+"\"");
				// sets the current scale as selected
				if(currentDoc.equalsIgnoreCase(id)){
					htmlStream.append("selected=\"selected\"");
				}
				htmlStream.append(">"+name+"</option>");
			}
			htmlStream.append("</select>");        
			scrollableDataResult.close();
			pageContext.getOut().print(htmlStream);
		} catch (EMFInternalError e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} 		
		finally{
			try {
				dataConnection.close();
			} catch (EMFInternalError e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		return SKIP_BODY;
	}

	public String getCurrentDoc() {
		return currentDoc;
	}

	public void setCurrentDoc(String currentDoc) {
		this.currentDoc = currentDoc;
	}

} // public class ListTag extends TagSupport






