/*
 *   Copyright 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago4Q.

    Spago4Q is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published 
    by the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spago4Q is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package it.eng.spago4q.presentation.tags.treehtmlgenerators;

import it.eng.spago.base.SourceBean;
import it.eng.spago.base.SourceBeanException;
import it.eng.spago.dispatching.service.list.basic.impl.DelegatedBasicListService;
import it.eng.spago4q.utilities.Spago4QConstants;

import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

public class AssessmentModelTreeHtmlGenerator extends ModelTreeHtmlGenerator {
	int id_=-1;
	int af_ = -1;
	int ac_ = -1;
	int at_ = -1;
	int ap_ = -1;

	int id_ma_=-1;
	int id_af_ = -1;
	int id_ac_ = -1;
	int id_at_ = -1;
	int id_ap_ = -1;

	@Override
	protected String getTreeName(List objectsList) {
		try {
			SourceBean sb = (SourceBean) objectsList.get(0);
			return (String) sb.getAttribute("ma_name");
		} catch (Exception e) {
			return "";
		}
	}

	@Override
	protected void addItems(StringBuffer htmlStream, List items,
			String initialPath) {

		int index = -1;
		Iterator it = items.iterator();

		while (it.hasNext()) {
			SourceBean item = (SourceBean) it.next();

			int id=((Integer) item.getAttribute("id")).intValue();
			int af = ((Integer) item.getAttribute("id_assessment_framework")).intValue();
			int ac = ((Integer) item.getAttribute("id_assessment_category")).intValue();
			int at = ((Integer) item.getAttribute("id_assessment_target")).intValue();
			int ap = ((Integer) item.getAttribute("id_assessment_practice")).intValue();
			int kpi = ((Integer) item.getAttribute("id_kpi")).intValue();

			index = index + 1;
			String name = "";
			String itemType = "";
			boolean isInitialPath=false;
			boolean isFinalPath=false;
			boolean bkpi = false;
			int parentId = DTREE_ROOT_ID;
			if(id_==-1 || id!=id_){
				id_=id;
				af_ = -1;
				ac_ = -1;
				at_ = -1;
				ap_ = -1;
				id_ma_ = index;
				parentId = -1;
				itemType = "ma";
				name = (String) item.getAttribute("ma_name");
				isInitialPath=true;
			}
			else if (af_ == -1 || af != af_){
				af_ = af;
				ac_ = -1;
				at_ = -1;
				ap_ = -1;
				id_af_ = index;
				parentId = id_ma_;
				itemType = "af";
				name = (String) item.getAttribute("af_name");
			}
			
			else if (ac_ == -1 || ac != ac_){
				ac_ = ac;
				at_ = -1;
				ap_ = -1;
				id_ac_ = index;
				parentId = id_af_;
				itemType = "ac";
				name = (String) item.getAttribute("ac_name");
			}
			
			else if (at_ == -1 || at != at_){
				at_ = at;
				ap_ = -1;
				id_at_ = index;
				parentId = id_ac_;
				itemType = "at";
				name = (String) item.getAttribute("at_name");
			}
			
			else if (ap_ == -1 || ap != ap_){
				ap_ = ap;
				id_ap_ = index;
				parentId = id_at_;
				itemType = "ap";
				name = (String) item.getAttribute("ap_name");
				isFinalPath=true;
			}

			try {
				item.updAttribute("itemType", itemType);
			} catch (SourceBeanException e) {
				e.printStackTrace();
			}
			
			bkpi = (kpi != 0) ? true : false;
			
			addItemForJSTree(htmlStream, item, index, parentId, name, isInitialPath, isFinalPath, bkpi);
			
			
			
			/*
			String path = "";
			if (initialPath.equalsIgnoreCase(path))
				addItemForJSTree(htmlStream, item, index, parentId, name, true);
			else
				addItemForJSTree(htmlStream, item, index, parentId, name, false);
			 */
		}
	}

	protected String createDetailObjectLink(SourceBean item) {
		HashMap editUrlParMap = new HashMap();
		editUrlParMap.put(Spago4QConstants.PAGE, "AssessmentModelKPIPage");
		editUrlParMap.put(Spago4QConstants.MODULE, "ListAssessmentModelKPIModule");
		editUrlParMap.put(Spago4QConstants.PAGE_MESSAGE, "DETAIL_SELECT");
		editUrlParMap.putAll(getItemParams(item));
		String editUrl = urlBuilder.getUrl(httpRequest, editUrlParMap);
		return editUrl;
	}

	protected String createAddObjectLink(SourceBean item) {
		HashMap addUrlParMap = new HashMap();
		addUrlParMap.put(Spago4QConstants.PAGE, "AssessmentModelKPIPage");
		addUrlParMap.put(Spago4QConstants.MODULE, "ListAssessmentModelKPIModule");
		addUrlParMap.put(Spago4QConstants.PAGE_MESSAGE, "DETAIL_NEW");
		addUrlParMap.putAll(getItemParams(item));
		String addUrl = urlBuilder.getUrl(httpRequest, addUrlParMap);
		return addUrl;
	}
	
	protected String createDeleteObjectLink(SourceBean item) {
		HashMap deleteUrlParMap = new HashMap();
		deleteUrlParMap.put(Spago4QConstants.PAGE, "AssessmentModelKPIPage");
		deleteUrlParMap.put(Spago4QConstants.MODULE, "ListAssessmentModelKPIModule");
		deleteUrlParMap.put(Spago4QConstants.PAGE_MESSAGE, DelegatedBasicListService.LIST_DELETE);
		deleteUrlParMap.putAll(getItemParamsDelete(item));
		String addUrl = urlBuilder.getUrl(httpRequest, deleteUrlParMap);
		return addUrl;
	}
	

	
	
	@Override
	protected Map getItemParams(SourceBean item) {
		Map m = new HashMap();
		int ma = ((Integer) item.getAttribute("id")).intValue();
		String ma_name=(String)item.getAttribute("ma_name");
		int af = ((Integer) item.getAttribute("id_assessment_framework")).intValue();
		String af_name = (String) item.getAttribute("af_name");
		int ac = ((Integer) item.getAttribute("id_assessment_category")).intValue();
		String ac_name = (String) item.getAttribute("ac_name");
		String ac_code = (String) item.getAttribute("ac_code");
		int at = ((Integer) item.getAttribute("id_assessment_target")).intValue();
		String at_name = (String) item.getAttribute("at_name");
		String at_code = (String) item.getAttribute("at_code");
		int ap = ((Integer) item.getAttribute("id_assessment_practice")).intValue();
		String ap_name = (String) item.getAttribute("ap_name");
		String ap_code = (String) item.getAttribute("ap_code");
		int kpi = ((Integer) item.getAttribute("id_kpi")).intValue();
		String kpi_name = (String) item.getAttribute("kpi_name");
		String kpi_code = (String) item.getAttribute("kpi_code");


		String itemType = (String) item.getAttribute("itemType");
		m.put("id", ma);
		m.put("ma_name", ma_name);
		m.put("af", af);
		m.put("af_name", af_name);
		m.put("ac", ac);
		m.put("ac_name", ac_name);
		if(ac_code!=null)
		m.put("ac_code", ac_code);
		m.put("at", at);
		m.put("at_name", at_name);
		if(at_code!=null)
		m.put("at_code", at_code);
		m.put("ap", ap);
		m.put("ap_name", ap_name);
		if(ap_code!=null)
		m.put("ap_code", ap_code);
		m.put("type", itemType);
		m.put("kpi", kpi);
		m.put("kpi_name", kpi_name);
		if(kpi_code!=null)
		m.put("kpi_code", kpi_code);

		return m;
	}

	@Override
	public Map getItemParamsDelete(SourceBean item) {
		Map m = new HashMap();
		int ma = ((Integer) item.getAttribute("id")).intValue();
		int af = ((Integer) item.getAttribute("id_assessment_framework")).intValue();
		int ac = ((Integer) item.getAttribute("id_assessment_category")).intValue();
		int at = ((Integer) item.getAttribute("id_assessment_target")).intValue();
		int ap = ((Integer) item.getAttribute("id_assessment_practice")).intValue();
		int kpi = ((Integer) item.getAttribute("id_kpi")).intValue();

		String itemType = (String) item.getAttribute("itemType");
		m.put("ma", ma);
		m.put("af", af);
		m.put("ac", ac);
		m.put("at", at);
		m.put("ap", ap);
		m.put("type", itemType);
		m.put("kpi", kpi);
		return m;
	}


	
	
	
	

}
