/*
 *   Copyright 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago4Q.

    Spago4Q is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published 
    by the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spago4Q is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package it.eng.spago4q.services.modules;


import it.eng.spago.base.SourceBean;
import it.eng.spago.dbaccess.DataConnectionManager;
import it.eng.spago.dbaccess.sql.DataConnection;
import it.eng.spago.dbaccess.sql.DataField;
import it.eng.spago.dbaccess.sql.DataRow;
import it.eng.spago.dbaccess.sql.SQLCommand;
import it.eng.spago.dbaccess.sql.result.DataResult;
import it.eng.spago.dbaccess.sql.result.InformationDataResult;
import it.eng.spago.dbaccess.sql.result.ScrollableDataResult;
import it.eng.spago.dispatching.module.detail.impl.DefaultDetailModule;
import it.eng.spago.error.EMFInternalError;

public class AssessmentModelDetailModule extends DefaultDetailModule {

	@Override
	public boolean insert(SourceBean request, SourceBean response) {
		SourceBean req=request;
		Boolean ok=super.insert(request, response);
		Boolean okMore=insertMore(req);
		return (ok && okMore);
	}

	// adding a corresponding row in dt_model_assessment_kpi
	public boolean insertMore(SourceBean request){

		DataConnectionManager dataConnectionManager;
		DataConnection dataConnection=null;
		SQLCommand sqlCommand;
		DataResult dataResult;
		ScrollableDataResult scrollableDataResult=null;
		Boolean ok=false;
		String name=(String)request.getAttribute("name");

		String statement=new String("select id_model_assess as id" +
				"					from dt_model_assess " +
				"					where name='"+name+"' AND " +
				"						(select count(*) " +
				"							from dt_model_assess_kpi " +
				"							where id_model_assess=(" +
				"								select id_model_assess as id " +
				"									from dt_model_assess " +
				"									where name='"+name+"'))=0");
		try {
			dataConnectionManager = DataConnectionManager.getInstance();
			dataConnection=dataConnectionManager.getConnection("spago4q");
			sqlCommand = dataConnection.createSelectCommand(statement);
			dataResult = sqlCommand.execute();

			if(dataResult!=null) {
				scrollableDataResult = (ScrollableDataResult)dataResult.getDataObject();
				DataRow dataRow=scrollableDataResult.getDataRow();
				DataField idF=dataRow.getColumn("id");
				String id=idF.getStringValue();

				String insertStatement="insert into dt_model_assess_kpi(" +
				"							id_model_assess,id_assessment_framework,id_assessment_category,id_assessment_target,id_assessment_practice,id_kpi,id_scale) " +
				"							values("+id+",0,0,0,0,0,0)";

				SQLCommand sqlCommandInsert = dataConnection.createInsertCommand(insertStatement);
				DataResult info=sqlCommandInsert.execute();
				ok=((InformationDataResult)info.getDataObject()).correctExecution();
				
			}
		} catch (EMFInternalError e) {
			e.printStackTrace();
		}
		finally{
			try {
				if(scrollableDataResult!=null)
				scrollableDataResult.close();
				dataConnection.close();
			} catch (EMFInternalError e) {
				e.printStackTrace();
			}
		}
		return ok;

	}
}


