/*
 *   Copyright 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago4Q.

    Spago4Q is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published 
    by the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spago4Q is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package it.eng.spago4q.services.modules;

import it.eng.spago.base.SourceBean;
import it.eng.spago.dbaccess.DataConnectionManager;
import it.eng.spago.dbaccess.sql.DataConnection;
import it.eng.spago.dbaccess.sql.DataField;
import it.eng.spago.dbaccess.sql.DataRow;
import it.eng.spago.dbaccess.sql.SQLCommand;
import it.eng.spago.dbaccess.sql.result.DataResult;
import it.eng.spago.dbaccess.sql.result.ScrollableDataResult;
import it.eng.spago.dispatching.module.AbstractModule;

import java.util.HashMap;

import javax.servlet.http.HttpServletRequest;

public class DataSourceParameterModule extends AbstractModule {

	protected HttpServletRequest httpRequest = null;
	protected DataConnection dataConnection=null;
	protected SQLCommand sqlCommand = null;
	protected DataResult dataResult = null;
	protected ScrollableDataResult scrollableDataResult=null;
	protected String type_id="";


	public void service(SourceBean serviceRequest, SourceBean serviceResponse)
	throws Exception {

		//I want to take all the parameters for this source_type

		type_id=(String)serviceRequest.getAttribute("type_id");

		
		try{
		DataConnectionManager dataConnectionManager=DataConnectionManager.getInstance();
		dataConnection=dataConnectionManager.getConnection("spago4q");

		HashMap<String, Boolean>parNames=new HashMap<String, Boolean>();

		String statement="SELECT name_parameter,encryption FROM e_source_type_parameter WHERE id_source_type='"+type_id+"'";
		sqlCommand = dataConnection.createSelectCommand(statement);
		dataResult = sqlCommand.execute();
		scrollableDataResult = (ScrollableDataResult)dataResult.getDataObject();

		DataRow dataRow;
		DataField nameF;
		DataField encF;
		String name;
		String enc;

		while(scrollableDataResult.hasRows()){
			dataRow=scrollableDataResult.getDataRow();
			nameF=dataRow.getColumn("name_parameter");
			encF=dataRow.getColumn("encryption");
			name=nameF.getStringValue();
			enc=encF.getStringValue();

			if(enc!=null && enc.equalsIgnoreCase("true"))
				parNames.put(name, true);
			else 
				parNames.put(name, false);

		}
		serviceResponse.setAttribute("parNames", parNames);
		}
		catch (Exception e) {
		}
		finally{
			if(dataConnection!=null)dataConnection.close();
			if(scrollableDataResult!=null)scrollableDataResult.close();
		}
	}
}
