/*
 *   Copyright 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago4Q.

    Spago4Q is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published 
    by the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spago4Q is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package it.eng.spago4q.services.modules;

import it.eng.spago.base.RequestContainer;
import it.eng.spago.base.SourceBean;
import it.eng.spago.dispatching.module.detail.impl.DefaultDetailModule;


public class DetailOperationFieldModule extends DefaultDetailModule {

	@Override
	public boolean insert(SourceBean request, SourceBean response) {
	
		RequestContainer requestContainer=RequestContainer.getRequestContainer();
		SourceBean serviceRequest=requestContainer.getServiceRequest();
		String mappingScript=(String)serviceRequest.getAttribute("mappingscript");
		try{
		if(mappingScript!=null && !mappingScript.equalsIgnoreCase("")){
			request.setAttribute("mapped",new String("Yes"));
		}
		else{
			request.setAttribute("mapped",new String(""));
		}
		}
		catch (Exception e) {
		}
		
		return super.insert(request, response);
	}

	@Override
	public boolean select(SourceBean request, SourceBean response) {
		// TODO Auto-generated method stub
		return super.select(request, response);
	}

	@Override
	public boolean update(SourceBean request, SourceBean response) {
		
		RequestContainer requestContainer=RequestContainer.getRequestContainer();
		SourceBean serviceRequest=requestContainer.getServiceRequest();
		String mappingScript=(String)serviceRequest.getAttribute("mappingscript");
		try{
		if(mappingScript!=null && !mappingScript.equalsIgnoreCase("")){
			serviceRequest.setAttribute("mapped",new String("Yes"));
		}
		else{
			serviceRequest.setAttribute("mapped",new String(""));
		}
		}
		catch (Exception e) {
		}
	
		
		return super.update(request, response);
	}

}
