/*
 *   Copyright 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago4Q.

    Spago4Q is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published 
    by the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spago4Q is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package it.eng.spago4q.services.modules;

import it.eng.spago.base.ResponseContainer;
import it.eng.spago.base.SourceBean;
import it.eng.spago.base.SourceBeanException;
import it.eng.spago.dbaccess.DataConnectionManager;
import it.eng.spago.dbaccess.sql.DataConnection;
import it.eng.spago.dbaccess.sql.DataField;
import it.eng.spago.dbaccess.sql.DataRow;
import it.eng.spago.dbaccess.sql.SQLCommand;
import it.eng.spago.dbaccess.sql.result.DataResult;
import it.eng.spago.dbaccess.sql.result.ScrollableDataResult;
import it.eng.spago.dispatching.module.detail.impl.DefaultDetailModule;
import it.eng.spago.error.EMFErrorHandler;
import it.eng.spago.error.EMFErrorSeverity;
import it.eng.spago.error.EMFUserError;

/*
 * Inserting two operation with same name and of the same process is forbidden 
*/
public class DetailOperationModule extends DefaultDetailModule{

	@Override
	public boolean insert(SourceBean request, SourceBean response) {
		ResponseContainer responseContainer=getResponseContainer();
		SourceBean serviceResponse=responseContainer.getServiceResponse();

		String id_extraction_process="";
		String name="";
		if(request.getAttribute("ID_EXTRACTION_PROCESS")!=null){
			id_extraction_process=String.valueOf(request.getAttribute("ID_EXTRACTION_PROCESS"));
		}
		if(request.getAttribute("NAME")!=null){
			name=String.valueOf(request.getAttribute("NAME"));
		}

		// I want to check I am not inserting two operation with the same name belonging to the same process
		Boolean isPresent=isPresent(id_extraction_process,name);

		if(isPresent.equals(false)){
			try {
				
				serviceResponse.setAttribute("ERROR","NONE");
				response.setAttribute("ERROR","NONE");
			} catch (SourceBeanException e) {
				e.printStackTrace();
			}
			return super.insert(request, response);}
		else
		{
			EMFErrorHandler engErrorHandler = getErrorHandler();
			engErrorHandler.addError(new EMFUserError(EMFErrorSeverity.WARNING, "10010"));			
			try {
				serviceResponse.setAttribute("ERROR","ERROR");
				response.setAttribute("ERROR","ERROR");
			} catch (SourceBeanException e) {
				e.printStackTrace();
			}
			return false;
		}
	}


	public Boolean isPresent(String id_extraction_process,String name){
		DataConnection dataConnection=null;
		ScrollableDataResult scrollableDataResult=null;
		DataResult dataResult=null;
		SQLCommand sqlCommand=null;
		String many=new String("1");
		try{

			DataConnectionManager dataConnectionManager=DataConnectionManager.getInstance();
			dataConnection=dataConnectionManager.getConnection("spago4q");

			String statement = "SELECT count(eo.id) as many FROM e_operation as eo,e_operation_process as eop WHERE eo.id=eop.operation_id AND eop.process_id="+id_extraction_process+" AND eo.name='"+name+"'";
			sqlCommand = dataConnection.createSelectCommand(statement);
			dataResult = sqlCommand.execute();
			scrollableDataResult = (ScrollableDataResult)dataResult.getDataObject();
			DataRow dataRow=scrollableDataResult.getDataRow();
			DataField dataField=dataRow.getColumn("many");
			many=dataField.getStringValue();
		}
		catch (Exception e) {
		}
		finally{
			try{
				if(scrollableDataResult!=null)
					scrollableDataResult.close();
				if(dataConnection!=null)
					dataConnection.close();
			}catch (Exception e) {
				// TODO: handle exception
			}
		}
		if(many.equalsIgnoreCase("0")) return false;
		else return true;
	}	

}
