/*
 *   Copyright 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago4Q.

    Spago4Q is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published 
    by the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spago4Q is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package it.eng.spago4q.services.modules;

import it.eng.spago.base.SourceBean;
import it.eng.spago.base.SourceBeanException;
import it.eng.spago.dispatching.module.detail.impl.DefaultDetailModule;
import it.eng.spago.error.EMFErrorHandler;
import it.eng.spago.error.EMFErrorSeverity;
import it.eng.spago.error.EMFUserError;
import it.eng.spago4q.utilities.sourceUtilities.AlreadyAssignedOperationUtil;

/*
 * Inserting a parameter of Polarion Source type a particular atribute called project
 */

public class DetailOperationParameterModule extends DefaultDetailModule {

	@Override
	public boolean insert(SourceBean request, SourceBean response) {

		String project=(String)request.getAttribute("project");
		Boolean alreadyPresent=new Boolean(false);
		if(project!=null && !project.equalsIgnoreCase("")){
			String id_operation=(String)request.getAttribute("id_operation");
			String oldName=(String)request.getAttribute("name");
			AlreadyAssignedOperationUtil already=new AlreadyAssignedOperationUtil();
			Boolean multiple=already.isMultiple(oldName, id_operation);
			changeWithProjectParameter(request, response, project);
			String name=(String)request.getAttribute("name");
			if(multiple.equals(false)){
				alreadyPresent=already.isPresent(name, id_operation);
			}
			already.close();

		}
		// I want to check, in the case of Polarion Parameters, that the parameter is not already present!
		if(alreadyPresent.equals(false))
			return super.insert(request, response);
		else
		{
			EMFErrorHandler engErrorHandler = getErrorHandler();
			engErrorHandler.addError(new EMFUserError(EMFErrorSeverity.WARNING, "10009"));			
			return false;
		}
	}

	@Override
	public boolean update(SourceBean request, SourceBean response) {
		return super.update(request, response);
	}

	public void changeWithProjectParameter(SourceBean request, SourceBean response, String project){
		String name=(String)request.getAttribute("name");
		name=project+"."+name;
		try {
			request.delAttribute("name");
			request.setAttribute("name",name);
		} catch (SourceBeanException e) {
			e.printStackTrace();
		}
	}


}
