/*
 *   Copyright 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago4Q.

    Spago4Q is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published 
    by the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spago4Q is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package it.eng.spago4q.services.modules;

import it.eng.spago.base.RequestContainer;
import it.eng.spago.base.SourceBean;
import it.eng.spago.dbaccess.DataConnectionManager;
import it.eng.spago.dbaccess.sql.DataConnection;
import it.eng.spago.dbaccess.sql.DataField;
import it.eng.spago.dbaccess.sql.DataRow;
import it.eng.spago.dbaccess.sql.SQLCommand;
import it.eng.spago.dbaccess.sql.result.DataResult;
import it.eng.spago.dbaccess.sql.result.ScrollableDataResult;
import it.eng.spago.dispatching.module.list.basic.impl.DefaultBasicListModule;
import it.eng.spago.error.EMFErrorHandler;
import it.eng.spago.error.EMFErrorSeverity;
import it.eng.spago.error.EMFUserError;

public class ListExtractionProcessModule extends DefaultBasicListModule {

	@Override
	public boolean delete(SourceBean request, SourceBean response) {

		String id_extraction_process="";
		boolean has=false;
		
		RequestContainer requestContainer=RequestContainer.getRequestContainer();
		SourceBean serviceRequest=requestContainer.getServiceRequest();
		
		if(serviceRequest.getAttribute("id_extraction_process")!=null){
			id_extraction_process=String.valueOf(serviceRequest.getAttribute("id_extraction_process"));
		}
		if(id_extraction_process!=""){
			has=hasOperations(id_extraction_process);
		}
		if(!has){
			return super.delete(request, response);
		}
		else
		{
			EMFErrorHandler engErrorHandler = getErrorHandler();
			engErrorHandler.addError(new EMFUserError(EMFErrorSeverity.WARNING, "10011"));			
			return false;
		}
	}



	protected boolean hasOperations(String id_extraction_process){
		DataConnectionManager dataConnectionManager;
		DataConnection dataConnection=null;
		SQLCommand sqlCommand;
		DataResult dataResult;
		ScrollableDataResult scrollableDataResult=null;		

		String statement="select count(process_id) as count from e_operation_process where process_id="+id_extraction_process;
		boolean has=false;

		try{
			dataConnectionManager = DataConnectionManager.getInstance();
			dataConnection=dataConnectionManager.getConnection("spago4q");
			sqlCommand = dataConnection.createSelectCommand(statement);
			dataResult = sqlCommand.execute();
			if(dataResult!=null) {
				scrollableDataResult = (ScrollableDataResult)dataResult.getDataObject();
				DataRow dataRow=scrollableDataResult.getDataRow();
				DataField idF=dataRow.getColumn("count");
				String count=(String)idF.getStringValue();
				if(count.equalsIgnoreCase("0"))has=false;
				else has=true;
			}
		}
		catch (Exception e) {
		}
		finally{
			try{
				if(dataConnection!=null){dataConnection.close();}
				if(scrollableDataResult!=null){scrollableDataResult.close();}
			}
			catch (Exception e) {
				// TODO: handle exception
			}
		}
		return has;
	}

}
