/*
 *   Copyright 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago4Q.

    Spago4Q is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published 
    by the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spago4Q is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package it.eng.spago4q.services.modules;

import it.eng.spago.base.SourceBean;
import it.eng.spago.dbaccess.DataConnectionManager;
import it.eng.spago.dbaccess.sql.DataConnection;
import it.eng.spago.dbaccess.sql.DataField;
import it.eng.spago.dbaccess.sql.DataRow;
import it.eng.spago.dbaccess.sql.SQLCommand;
import it.eng.spago.dbaccess.sql.result.DataResult;
import it.eng.spago.dbaccess.sql.result.ScrollableDataResult;
import it.eng.spago.dispatching.module.AbstractHttpModule;

import javax.servlet.http.HttpServletRequest;

/*
 This Module is called after the insert of a new operation.
	Inserts in the table e_oepration_process the relation between
	the new Operation and the current selected process 
 */

public class OperationProcessInsert extends AbstractHttpModule{

	protected HttpServletRequest httpRequest = null;
	protected DataConnection dataConnection=null;
	protected SQLCommand sqlCommand = null;
	protected DataResult dataResult = null;
	protected ScrollableDataResult scrollableDataResult=null;
	protected String id_extraction_process="";
	protected String name="";
	protected String id_operation="";
	protected String message="";



	public void service(SourceBean serviceRequest, SourceBean serviceResponse)
	throws Exception {
		String error="";
		if(serviceRequest.getAttribute("ID_EXTRACTION_PROCESS")!=null){
			id_extraction_process=String.valueOf(serviceRequest.getAttribute("ID_EXTRACTION_PROCESS"));
		}
		if(serviceRequest.getAttribute("ERROR")!=null){
			error=String.valueOf(serviceRequest.getAttribute("ERROR"));
		}
		if(!error.equalsIgnoreCase("ERROR") && !error.equalsIgnoreCase("")){
		try{

			DataConnectionManager dataConnectionManager=DataConnectionManager.getInstance();
			dataConnection=dataConnectionManager.getConnection("spago4q");


			if(serviceRequest.getAttribute("NAME")!=null){
				name=String.valueOf(serviceRequest.getAttribute("NAME"));
			}


			String statement = "select eo.id as id FROM e_operation as eo WHERE eo.id NOT IN(select operation_id from e_operation_process WHERE process_id!="+id_extraction_process+") AND eo.name='"+name+"'";
			sqlCommand = dataConnection.createSelectCommand(statement);
			dataResult = sqlCommand.execute();
			scrollableDataResult = (ScrollableDataResult)dataResult.getDataObject();
			DataRow dataRow=scrollableDataResult.getDataRow();
			DataField dataField=dataRow.getColumn("id");
			id_operation=dataField.getStringValue();

			String insertStatement="INSERT into e_operation_process(operation_id,process_id) values ('"+id_operation+"','"+id_extraction_process+"')";
			sqlCommand = dataConnection.createInsertCommand(insertStatement);
			dataResult = sqlCommand.execute();

		}
		catch (Exception e) {
		}
		finally{
			if(scrollableDataResult!=null)
				scrollableDataResult.close();
			if(dataConnection!=null)
				dataConnection.close();
		}
	}
	} // closes if not error 

}
