/*
 *   Copyright 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago4Q.

    Spago4Q is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published 
    by the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spago4Q is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package it.eng.spago4q.services.modules;

import it.eng.spago.base.SourceBean;
import it.eng.spago.dispatching.module.AbstractModule;
import it.eng.spago.error.EMFErrorHandler;
import it.eng.spago.error.EMFErrorSeverity;
import it.eng.spago.error.EMFUserError;
import it.eng.spago4q.utilities.parameterUtilities.StoreParameterUtilities;

public class StoreDataSourceParameterModule extends AbstractModule {

	public void service(SourceBean serviceRequest, SourceBean serviceResponse)
	throws Exception {

		String type_id="";		
		String e_data_source_id="";

		if(serviceRequest.getAttribute("type_id")!=null){
			type_id=(String)serviceRequest.getAttribute("type_id");	
		}


		if(serviceRequest.getAttribute("e_data_source_id")!=null){
			e_data_source_id=(String)serviceRequest.getAttribute("e_data_source_id");	
		}

		StoreParameterUtilities util=new StoreParameterUtilities();
		Boolean ok=util.storeDataSourceParameter(serviceRequest,type_id,e_data_source_id);


		if(ok.equals(true)){
			EMFErrorHandler engErrorHandler = getErrorHandler();
			engErrorHandler.addError(new EMFUserError(EMFErrorSeverity.INFORMATION, "10004"));			
		}
		else{
			EMFErrorHandler engErrorHandler = getErrorHandler();
			engErrorHandler.addError(new EMFUserError(EMFErrorSeverity.WARNING, "10013"));			
		}


	}


}



