/*
 *   Copyright 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago4Q.

    Spago4Q is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published 
    by the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spago4Q is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package it.eng.spago4q.utilities.sourceUtilities;

import it.eng.spago.dbaccess.DataConnectionManager;
import it.eng.spago.dbaccess.sql.DataConnection;
import it.eng.spago.dbaccess.sql.DataField;
import it.eng.spago.dbaccess.sql.DataRow;
import it.eng.spago.dbaccess.sql.SQLCommand;
import it.eng.spago.dbaccess.sql.result.DataResult;
import it.eng.spago.dbaccess.sql.result.ScrollableDataResult;
import it.eng.spago.error.EMFInternalError;

import java.util.Iterator;
import java.util.Vector;

public class AlreadyAssignedSourceUtil {

	protected DataConnection dataConnection=null;
	protected DataConnectionManager dataConnectionManager=null;
	protected SQLCommand sqlCommand = null;
	protected DataResult dataResult = null;
	protected ScrollableDataResult scrollableDataResult= null;
	protected DataRow dataRow=null;
	protected DataField dataField=null;

	private static final String getNames="select name_parameter from e_source_type_parameter ";	
	private static final String howManyAlready="select count(e_data_source_id) as many from e_data_source_parameters ";	

	/*
	This class provides methods to assign parameters to data sources
	*/

	public AlreadyAssignedSourceUtil() {
		try {
			dataConnectionManager = DataConnectionManager.getInstance();

			dataConnection = dataConnectionManager.getConnection("spago4q");
		}
		catch (EMFInternalError e) {
			e.printStackTrace();
		}
	}


	public Vector<String> getAvalaibleNames(String type_id, String e_data_source_id){

		Vector<String> parametersNames=new Vector<String>();
		Vector<String> avalaibleParametersNames=new Vector<String>();
		try {
			String statement1=getNames+" WHERE id_source_type="+type_id;
			sqlCommand = dataConnection.createSelectCommand(statement1);
			dataResult = sqlCommand.execute();
			scrollableDataResult = (ScrollableDataResult)dataResult.getDataObject();

			// First I get the parameters
			for(int i=0;i<scrollableDataResult.getRowsNumber();i++){
				DataRow dataRow=scrollableDataResult.getDataRow();
				DataField nameF=dataRow.getColumn("name_parameter");
				String name=nameF.getStringValue();
				parametersNames.add(name);
			}

			String statement = howManyAlready;
			String currStatement;

			for (Iterator iterator = parametersNames.iterator(); iterator.hasNext();) {
				String name = (String) iterator.next();
				currStatement=statement+"where e_data_source_id="+e_data_source_id+" AND name='"+name+"'";
				sqlCommand = dataConnection.createSelectCommand(currStatement);
				dataResult = sqlCommand.execute();
				scrollableDataResult = (ScrollableDataResult)dataResult.getDataObject();
				DataRow dataRow=scrollableDataResult.getDataRow();
				DataField many=dataRow.getColumn("many");
				String manyS=many.getStringValue();
				if(manyS.equalsIgnoreCase("0")){
					avalaibleParametersNames.add(name);
				}		
			}
		
		} 
		catch (EMFInternalError e) {
			e.printStackTrace();
		} 		 		
		finally{
			try {
				if(scrollableDataResult!=null){
					scrollableDataResult.close();
				}
				if(dataConnection!=null){
					dataConnection.close();
				}
			} catch (EMFInternalError e) {
				e.printStackTrace();
			}
		}
		return avalaibleParametersNames;
	}

}

