/*
 *   Copyright 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago4Q.

    Spago4Q is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published 
    by the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spago4Q is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package it.eng.spago4q.utilities.sourceUtilities;

import it.eng.spago.dbaccess.DataConnectionManager;
import it.eng.spago.dbaccess.sql.DataConnection;
import it.eng.spago.dbaccess.sql.DataField;
import it.eng.spago.dbaccess.sql.DataRow;
import it.eng.spago.dbaccess.sql.SQLCommand;
import it.eng.spago.dbaccess.sql.result.DataResult;
import it.eng.spago.dbaccess.sql.result.ScrollableDataResult;
import it.eng.spago.error.EMFInternalError;

public class ProcessSourceType {

	protected DataConnection dataConnection=null;
	protected DataConnectionManager dataConnectionManager=null;
	protected SQLCommand sqlCommand = null;
	protected DataResult dataResult = null;
	protected ScrollableDataResult scrollableDataResult=null;

	/*
	 * This class provides a method to get the source_type of a process
	 */
	
	private static final String query="SELECT est.name as name " +
			"							FROM e_source_type as est," +
			"								 e_source_type_interface as esti," +
			"								 e_extraction_process as eep" +
			"						 	WHERE esti.source_type_id=est.id  AND" +
			"								  eep.interface_id=esti.interface_id ";
	
	public String getProcessSourceType(String id_extraction_process){
		try {
			dataConnectionManager=DataConnectionManager.getInstance();
			dataConnection=dataConnectionManager.getConnection("spago4q");
			String statement=query+" AND eep.id="+id_extraction_process;
			sqlCommand = dataConnection.createSelectCommand(statement);
			dataResult = sqlCommand.execute();
			scrollableDataResult = (ScrollableDataResult)dataResult.getDataObject();
			DataRow dataRow=scrollableDataResult.getDataRow();
			DataField dataField=dataRow.getColumn("name");
			String name=dataField.getStringValue();
			return name;
		} catch (EMFInternalError e) {
			e.printStackTrace();
		}
		finally{
			try {
			if(scrollableDataResult!=null)
			
					scrollableDataResult.close();
			
			if(dataConnection!=null)
				dataConnection.close();			
		}
			catch (EMFInternalError e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}
	return "";
	}
}
		
	

