/*
 *   Copyright 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago4Q.

    Spago4Q is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published 
    by the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spago4Q is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package it.eng.spago4q.utilities.urls;

import it.eng.spago.base.ApplicationContainer;
import it.eng.spago.configuration.ConfigSingleton;
import it.eng.spago4q.utilities.Spago4QConstants;

public class UrlBuilderFactory {

	public static IUrlBuilder getUrlBuilder() {
		ApplicationContainer spagoContext = ApplicationContainer.getInstance();
		IUrlBuilder urlBuilder = (IUrlBuilder)spagoContext.getAttribute(Spago4QConstants.URL_BUILDER);
		if(urlBuilder==null) {
			ConfigSingleton spagoconfig = ConfigSingleton.getInstance();
			// get mode of execution
			String sbiMode = (String)spagoconfig.getAttribute(Spago4QConstants.SPAGO4Q_MODE);   
			// based on mode get spago object and url builder
			if (sbiMode.equalsIgnoreCase(Spago4QConstants.SPAGO4Q_MODE_WEB)) {
				urlBuilder = new WebUrlBuilder();		
			} else if  (sbiMode.equalsIgnoreCase(Spago4QConstants.SPAGO4Q_MODE_PORTLET)){
				urlBuilder = new PortletUrlBuilder();
			}
			spagoContext.setAttribute(Spago4QConstants.URL_BUILDER, urlBuilder);
		}	
		return urlBuilder;
	}
	
	public static IUrlBuilder getUrlBuilder(String channelType) {
		IUrlBuilder urlBuilder = null;
		// based on mode get spago object and url builder
		if (channelType.equalsIgnoreCase(Spago4QConstants.SPAGO4Q_MODE_WEB) || channelType.equalsIgnoreCase(Spago4QConstants.SPAGO4Q_MODE_HTTP)) {
			urlBuilder = new WebUrlBuilder();		
		} else if  (channelType.equalsIgnoreCase(Spago4QConstants.SPAGO4Q_MODE_PORTLET)){
			urlBuilder = new PortletUrlBuilder();
		}
		return urlBuilder;
	}	
		
	
}
